﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace NotovyEditor
{

    public partial class Form1 : Form
    {
        Graphics g;//grafika na kterou budem kreslit
        string filename = "";
        Bitmap[] takty;
        Bitmap[] noty_nahoru; 
        Bitmap[] noty_nahoru_krizek;
        Bitmap[] noty_dolu;
        Bitmap[] noty_dolu_krizek;
        Bitmap[] noty_cele;
        Bitmap[] pomlky;
        Bitmap klic;
        int gposun = 50;
        int sirkalinky = 6;
        XmlReader file;
        double doba;
        int pozice;
        int idnoty;
        int delkanoty;
        double takt;
        double yposun;
        //parametry pro posun not
        string[] typynot_nahoru = {"C", "Cis", "D", "Dis", "E", "F", "Fis", "G", "Gis", "A", "Ais", "H"};
        double[] posun_nahoru =   {21,    21,   15,   15,   6  ,  0,    0,   -6 ,  -6,    -12  , -12, -15};  
        string[] typynot_dolu   = {"c", "cis", "d", "dis", "e", "f", "fis", "g", "gis", "a", "ais", "h"};
        double[] posun_dolu =     {-21,  -21,  -24, -24,  -27, -30, -30,  -33, -33, -36, -36,  -39   };
        bool nahoru, krizek,tecka;
        public Form1()
        {
            InitializeComponent();
            //nacteni bitmap
            klic = new Bitmap("images/klic.png");
            takty = new Bitmap[3];
            takty[0] = new Bitmap("images/takt_3.png");
            takty[1] = new Bitmap("images/takt_4.png");
            takty[2] = new Bitmap("images/takt_5.png");
            noty_nahoru = new Bitmap[3];
            noty_nahoru[0] = new Bitmap("images/nota_nahoru_0.png");
            noty_nahoru[1] = new Bitmap("images/nota_nahoru_1.png");
            noty_nahoru[2] = new Bitmap("images/nota_nahoru_2.png");
            noty_cele = new Bitmap[2];
            noty_cele[0] = new Bitmap("images/nota_4.png");
            noty_cele[1] = new Bitmap("images/nota_krizek_4.png");
            noty_nahoru_krizek = new Bitmap[3];
            noty_nahoru_krizek[0] = new Bitmap("images/nota_krizek_nahoru_0.png");
            noty_nahoru_krizek[1] = new Bitmap("images/nota_krizek_nahoru_1.png");
            noty_nahoru_krizek[2] = new Bitmap("images/nota_krizek_nahoru_2.png");
            noty_dolu = new Bitmap[3];
            noty_dolu[0] = new Bitmap("images/nota_dolu_0.png");
            noty_dolu[1] = new Bitmap("images/nota_dolu_1.png");
            noty_dolu[2] = new Bitmap("images/nota_dolu_2.png");
            noty_dolu_krizek = new Bitmap[3];
            noty_dolu_krizek[0] = new Bitmap("images/nota_krizek_dolu_0.png");
            noty_dolu_krizek[1] = new Bitmap("images/nota_krizek_dolu_1.png");
            noty_dolu_krizek[2] = new Bitmap("images/nota_krizek_dolu_2.png");

            pomlky = new Bitmap[4];
            pomlky[0] = new Bitmap("images/pomlka_0.png");
            pomlky[1] = new Bitmap("images/pomlka_1.png");
            pomlky[2] = new Bitmap("images/pomlka_2.png");
            pomlky[3] = new Bitmap("images/pomlka_3.png");
        }
        /// <summary>
        /// Hlavni metoda ktera vykresluje noty a notovou linku na formular
        /// </summary>
        /// <param name="posun">cislo o ktere se ma posunout obraz pri scrollovani</param>
        private void Draw(int posun)
        {
            g = this.CreateGraphics();
            file = new XmlTextReader(filename);
            g.Clear(this.BackColor);
            //kresli linky a klic
            for (int i = 0; i < 5; i++)
                g.DrawLine(Pens.Black, 0,i * sirkalinky + gposun, this.ClientRectangle.Width, i * sirkalinky + gposun);
            g.DrawImage(klic, 0-posun, gposun-11);
            doba = 1;
            pozice = 40;
            try
            {
                while (file.Read())
                {
                    if (file.HasAttributes)
                    {
                        if ((int)(doba % takt) == 0)
                        {
                            g.DrawLine(Pens.Black, posun, gposun, posun + 30, gposun);
                            posun += 5;
                        }
                        tecka = false;
                        switch (file.Name)
                        {
                            case "skladba":
                                file.MoveToAttribute(0);
                                if (file.Value == "3/4")
                                {
                                    g.DrawImage(takty[0], 25 - posun, gposun);
                                    takt = 3;
                                }
                                if (file.Value == "4/4")
                                {

                                    g.DrawImage(takty[1], 25 - posun, gposun);
                                    takt = 4;
                                }
                                if (file.Value == "5/4")
                                {
                                    g.DrawImage(takty[2], 25 - posun, gposun);
                                    takt = 5;
                                }
                                break;
                            case "nota":
                                file.MoveToAttribute(1);
                                //jestli je nahoru nebo dolu
                                for (int i = 0; i < typynot_nahoru.Length; i++)
                                    if (file.Value == typynot_nahoru[i])
                                    {
                                        nahoru = true;
                                        yposun = posun_nahoru[i]/2+1;
                                    }
                                for (int i = 0; i < typynot_dolu.Length; i++)
                                    if (file.Value == typynot_dolu[i])
                                    {
                                        nahoru = false;
                                        yposun = posun_dolu[i]/2+1;
                                    }
                                //zjisteni jestli je tam krizek ci ne
                                if (file.Value.Length > 1)
                                    krizek = true;
                                else krizek = false;
                                file.MoveToAttribute(0);
                                //urcime id bitmapy kterou budeme kreslit
                                switch (file.Value)
                                {
                                    case "0.5":
                                        idnoty = 0;
                                        doba += 0.5;
                                        break;
                                    case "1":
                                        idnoty = 1;
                                        doba += 1;
                                        break;
                                    case "1.5":
                                        idnoty = 1;
                                        tecka = true; 
                                        doba += 2.5;
                                        break;
                                    case "2":
                                        idnoty = 2;
                                        doba += 2;
                                        break;
                                    case "3":
                                        idnoty = 2;
                                        tecka = true;
                                        doba += 3;
                                        break;
                                    case "4":
                                        doba += 4;
                                        if (krizek)
                                        {
                                            g.DrawImage(noty_cele[1], pozice - posun, gposun + (int)yposun);
                                            pozice += noty_cele[1].Width + 5;
                                        }
                                        else
                                        {
                                            g.DrawImage(noty_cele[0], pozice - posun, gposun + (int)yposun);
                                            pozice += noty_cele[0].Width + 5;
                                        }
                                        break;
                                }



                                //vykresleni noty
                                if (nahoru)
                                {
                                    if (krizek)
                                    {
                                        g.DrawImage(noty_nahoru_krizek[idnoty], pozice - posun, gposun +(int)yposun);
                                        
                                        if (tecka) g.FillEllipse(Brushes.Black, pozice - posun+10, gposun + (int)yposun, 5, 5);
                                        pozice += noty_nahoru_krizek[idnoty].Width + 5;
                                    }
                                    else
                                    {
                                        g.DrawImage(noty_nahoru[idnoty], pozice - posun, gposun + (int)yposun);
                                        if (tecka) g.FillEllipse(Brushes.Black, pozice - posun+10, gposun + (int)yposun, 5, 5);
                                        pozice += noty_nahoru[idnoty].Width + 5;
                                    }
                                }
                                else
                                {
                                    if (krizek)
                                    {
                                        g.DrawImage(noty_dolu_krizek[idnoty], pozice - posun, gposun + (int)yposun);
                                        if (tecka) g.FillEllipse(Brushes.Black, pozice - posun+10, gposun + (int)yposun, 5, 5);
                                        pozice += noty_dolu_krizek[idnoty].Width + 5;
                                    }
                                    else
                                    {
                                        g.DrawImage(noty_dolu[idnoty], pozice - posun, gposun + (int)yposun);
                                        if (tecka) g.FillEllipse(Brushes.Black, pozice - posun+10, gposun + (int)yposun, 5, 5);
                                        pozice += noty_dolu[idnoty].Width + 5;
                                    }
                                }
                                if (tecka)
                                    pozice += 10;
                                doba += delkanoty;
                                
                                break;
                            //kresleni pomlky
                            case "pomlka":
                                file.MoveToAttribute(0);
                                switch (file.Value)
                                {
                                    case "0.5":
                                        doba += 0.5;
                                        g.DrawImage(pomlky[0], pozice - posun, gposun+7);
                                        pozice += pomlky[0].Width + 5;
                                        break;
                                    case "1":
                                        doba += 1;
                                        g.DrawImage(pomlky[1], pozice - posun, gposun + 7);
                                        pozice += pomlky[1].Width + 5;
                                        break;
                                    case "1.5":
                                        doba += 1.5;
                                        g.DrawImage(pomlky[1], pozice - posun, gposun + 7);
                                        pozice += pomlky[1].Width + 5;
                                        g.FillEllipse(Brushes.Black, pozice - posun + 10, gposun + (int)yposun, 5, 5);
                                        pozice += 10;
                                        break;
                                    case "2":
                                        doba += 2;
                                        g.DrawImage(pomlky[2], pozice - posun, gposun + 9);
                                        pozice += pomlky[2].Width + 5;
                                        break;
                                    case "3":
                                        doba += 3;
                                        g.DrawImage(pomlky[2], pozice - posun, gposun + 9);
                                        pozice += pomlky[2].Width + 5;
                                        g.FillEllipse(Brushes.Black, pozice - posun + 10, gposun + (int)yposun, 5, 5);
                                        pozice += 10;
                                        break;
                                    case "4":
                                        doba += 4;
                                        g.DrawImage(pomlky[3], pozice - posun, gposun + 6);
                                        pozice += pomlky[3].Width + 5;
                                        break;

                                }
                                break;
                        }
                    }

                }
            }
            finally
            {
                file.Close();
            }
        }
        private void otevřítToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //nacteni ze souboru
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                filename = openFileDialog1.FileName;
                Draw(0);
            }
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            //hrozne pekne napsane, pokazde se to nacte a prekresli cele
            if (filename != "")
            {
                Draw(trackBar1.Value);
                Text = Convert.ToString(trackBar1.Value);
            }
        }
    }
}